$!
$! Script called when open failure on file occurs.
$!
$ write net_link "<DNETRECMODE>"
$ gosub get_path_translated			!cgi_symbols
$ if f$type(WWW_PATH_TRANSLATED) .eqs. ""
$ then
$ copy sys$input net_link:
Status: 404 Openfail handler
Content-type: text/plain

Requested document could not be found, no translation.
$ exit
$ endif
$!
$! Convert translated path and see if index.URL present.
$!
$ gosub convert_translation
$ map_file = f$parse("index.url",vms_translation)
$ if map_file .eqs. "" .OR. f$search(map_file) .eqs. ""
$ then
$     write net_link "Status: 404 Openfail handler"
$    write net_link "Content-type: text/plain"
$    write net_link ""
$    write net_link "Error:"
$    write net_link/symbol "File ", WWW_PATH_TRANSLATED, " (", WWW_PATH_INFO, -
	") could not be opened"
$    write net_link/symbol "VMS specification: ", vms_translation
$    exit
$ endif
$!
$! Search index.url for vms_fname
$!
$ vms_redirect = ""
$ gosub find_redirect
$ if vms_redirect .nes. ""
$ then
$    write net_link/symbol "Location: ", vms_redirect
$    write net_link ""
$    write net_link "New location at ", vms_redirect
$ else
$    write net_link "Status: 404 Openfail handler"
$    write net_link "Content-type: text/plain"
$    write net_link ""
$    write net_link "Error:"
$    write net_link/symbol "File ", WWW_PATH_TRANSLATED, " (", -
WWW_PATH_INFO, ") could not be opened"
$    write net_link/symbol "VMS specification: ", vms_translation
$    write net_link "index.url present"
$ endif
$ exit
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Convert P2 into www_path_translated and place link into CGI mode.
$!
$ get_path_translated:
$ prefix = "/" + f$element(1,"/",p2)+"/"+f$element(2,"/",P2)
$ www_path_info = p2 - prefix
$ if www_path_info .nes. ""
$ then
$    write net_link "<DNETXLATEV>"
$    write net_link www_path_info
$    read net_link translation
$    if translation .nes. "" then www_path_translated = translation
$ endif
$ write net_link "<DNETCGI>"
$ wwwexec_rundown_string == "</DNETCGI>"
$ return
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! convert www_path_translated to vms_translation:
$!    /name -> name
$!    /disk/name -> disk:[00000]name
$!    /disk/dir/name -> disk:[dir]name
$!
$ convert_translation:
$ vms_translation = f$element(1,"/",www_path_translated)
$ vms_fname = vms_translation
$ delimiter = ":["
$ final_delim = ":[000000]"
$ level = 2
$ cur_part = f$element(2,"/",www_path_translated)
$ if cur_part .eqs. "/" then return
$ next_level:
$    level = level + 1
$    next_part = f$element(level,"/",www_path_translated)
$    if next_part .eqs. "/"
$    then
$       vms_fname = cur_part
$	vms_translation = vms_translation + final_delim + cur_part
$	return
$    endif
$    vms_translation = vms_translation + delimiter + cur_part
$    delimiter = "."
$    final_delim = "]"
$    cur_part = next_part
$    goto next_level
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Open map_file and search for line that defines a redirect for vms_fname,
$! setting vms_redirect to the corresponding value.
$!
$ find_redirect:
$ fname = f$edit(vms_fname,"UPCASE")
$ open/read/share mf 'map_file'/error=fred_openfail
$ on warning then goto fred_abort
$ read/error=fred_abort mf line			! skip first line
$ fred_next_line:
$   read/error=fred_abort mf line
$   line = f$edit(line,"TRIM,COMPRESS")
$   key = f$element(0," ",line)
$   value = f$element(1," ",line)
$   if f$edit(key,"UPCASE") .nes. fname then goto fred_next_line
$   if value .eqs. " " then goto fred_next_line
$   vms_redirect = value
$!
$ fred_abort:
$ close mf
$ set on
$ fred_openfail:
$ return
$ 
